/* Copyright (C) 2006 Anton Fedorov <datacompboy@call2ru.com>

   nss_vserver: provide auth on host according to passwd & shadow files
		in vservers.
   You can find info about vserver at http://linux-vserver.org/
   See README for details
   
   Feel free to use code as you want
 */

static pthread_key_t contextkey;
static pthread_once_t context_key_once = PTHREAD_ONCE_INIT;

static void context_destroy(void * buf)
{
  if (NULL!=buf) {
	context_free((ENT_CONTEXT_T *)buf);
	free(buf);
  }
}

static void context_create_key()
{
  pthread_key_create(&contextkey, context_destroy);
}

static ENT_CONTEXT_T * get_context()
{
  ENT_CONTEXT_T * context;
  pthread_once(&context_key_once, context_create_key);
  context=pthread_getspecific(contextkey);
  if (NULL==context) {
	context = (ENT_CONTEXT_T *) malloc(sizeof(ENT_CONTEXT_T));
	if (NULL == context)
	  return context;
	context_init(context);
	pthread_setspecific(contextkey, context);
  }
  return context;
}

